//
//  ViewController.m
//  SAJavaScript
//
//  Created by 余西安 on 16/3/17.
//  Copyright © 2016年 Sian. All rights reserved.
//

#import "ViewController.h"
#import <JavaScriptCore/JavaScriptCore.h>

@protocol SAJSExport <JSExport>
- (void)showMessage:(JSValue *)message;
@end

@interface ViewController () <UIWebViewDelegate, SAJSExport>
@property (nonatomic, strong) UIWebView *webView;
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.webView = [[UIWebView alloc] init];
    self.webView.delegate = self;
    self.webView.frame = self.view.bounds;
    [self.view addSubview:self.webView];
    NSURL *url = [NSURL URLWithString:@"http://www.yusian.com"];
    [self.webView loadRequest:[NSURLRequest requestWithURL:url]];
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    JSContext *context = [self.webView valueForKeyPath:@"documentView.webView.mainFrame.javaScriptContext"];
    // 1、Block方法
    context[@"ocShow"] = ^(){
        NSLog(@"来自JS的问候...");
    };
    // 模拟JS调用
    [context evaluateScript:@"ocShow()"];
    
    // 2、代理方法
    [context setObject:self forKeyedSubscript:@"webView"];
    // 模拟JS调用webView.showMessage()方法
    [context evaluateScript:@"webView.showMessage('Hello JavaScript')"];
}

- (void)showMessage:(JSValue *)message
{
    [[[UIAlertView alloc] initWithTitle:nil message:[message toString] delegate:nil cancelButtonTitle:@"朕知道了" otherButtonTitles:nil, nil] show];
}
@end
